import os
import time
import re
import sys
import tkFileDialog
import Tkinter


#############################################
# Function: crc32
#############################################
def crc32(tsbk):
	g = (1<<26) + (1<<23) + (1<<22) + (1<<16) + (1<<12) + (1<<11) + (1<<10) + (1<<8) + (1<<7) + (1<<5) + (1<<4) + (1<<2) + (1<<1) + (1<<0)
	reg = 0
	for i in range(12,(len(tsbk)/2)):
		for j in range(8):
			bits = tsbk[i*2+0:i*2+2]
			bit = (int(bits,16) >> (7-j)) & 1
			reg = ((reg << 1) | bit) & 0x1ffffffff
			if (reg & 0x100000000):
				reg = (reg & 0xffffffff) ^ g
	reg = reg ^ 0xffffffff
	return (reg)


#############################################
# Function: crc16
#############################################
def crc16(tsbk):
	g = (1<<12) + (1<<5) + (1<<0)
	reg = 0
	for i in range(12):
		for j in range(8):
			bits = tsbk[i*2+0:i*2+2]
			bit = (int(bits,16) >> (7-j)) & 1
			reg = ((reg << 1) | bit) & 0x1ffff
			if (reg & 0x10000):
				reg = (reg & 0xffff) ^ g
	reg = reg ^ 0xffff
	return (reg)


#############################################
# Function: filter_ctrl_broadcasts
#############################################
def filter_ctrl_broadcasts(tsbk,opcode):
	global control_iden_up_vu
	global control_iden_up_vu_count
	global control_iden_up
	global control_iden_up_count
	global control_adj_sts_bcst
	global control_adj_sts_bcst_count
	global control_net_sts_bcst
	global control_net_sts_bcst_count
	global control_p_parm_bcst
	global control_p_parm_bcst_count
	global control_rfss_sts_bcst
	global control_rfss_sts_bcst_count
	global control_sys_srv_bcst
	global control_sys_srv_bcst_count
	global control_sccb
	global control_sccb_count

	#
	# Check broadcast messages and output them only once
	#
						
	broadcast_match = 0
	
	if (opcode == 0x34):
		if (cmp(tsbk[2:20],control_iden_up_vu) == 0):
			control_iden_up_vu_count = control_iden_up_vu_count + 1
			broadcast_match = 1
		else:
			control_iden_up_vu = tsbk[2:20]
			control_iden_up_vu_count = 0
			broadcast_match = 1
				
	if (opcode == 0x3d):
		if (cmp(tsbk[2:20],control_iden_up) == 0):
			control_iden_up_count = control_iden_up_count + 1
			broadcast_match = 1
		else:
			control_iden_up = tsbk[2:20]
			control_iden_up_count = 0
			broadcast_match = 1
						
	if (opcode == 0x3c):
		if (cmp(tsbk[2:20],control_adj_sts_bcst) == 0):
			control_adj_sts_bcst_count = control_adj_sts_bcst_count + 1
			broadcast_match = 1
		else:
			control_adj_sts_bcst = tsbk[2:20]
			control_adj_sts_bcst_count = 0
			broadcast_match = 1
						
	if (opcode == 0x3b):
		if (cmp(tsbk[2:20],control_net_sts_bcst) == 0):
			control_net_sts_bcst_count = control_net_sts_bcst_count + 1
			broadcast_match = 1
		else:
			control_net_sts_bcst = tsbk[2:20]
			control_net_sts_bcst_count = 0
			broadcast_match = 1
					
	if (opcode == 0x3e):
		if (cmp(tsbk[2:20],control_p_parm_bcst) == 0):
			control_p_parm_bcst_count = control_p_parm_bcst_count + 1
			broadcast_match = 1
		else:
			control_p_parm_bcst = tsbk[2:20]
			control_p_parm_bcst_count = 0
			broadcast_match = 1
						
	if (opcode == 0x3a):
		if (cmp(tsbk[2:20],control_rfss_sts_bcst) == 0):
			control_rfss_sts_bcst_count = control_rfss_sts_bcst_count + 1
			broadcast_match = 1
		else:
			control_rfss_sts_bcst = tsbk[2:20]
			control_rfss_sts_bcst_count = 0
			broadcast_match = 1
						
	if (opcode == 0x38):
		if (cmp(tsbk[2:20],control_sys_srv_bcst) == 0):
			control_sys_srv_bcst_count = control_sys_srv_bcst_count + 1
			broadcast_match = 1
		else:
			control_sys_srv_bcst = tsbk[2:20]
			control_sys_srv_bcst_count = 0
			broadcast_match = 1
						
	if (opcode == 0x39):
		if (cmp(tsbk[2:20],control_sccb) == 0):
			control_sccb_count = control_sccb_count + 1
			broadcast_match = 1
		else:
			control_sccb = tsbk[2:20]
			control_sccb_count = 0
			broadcast_match = 1

	return (broadcast_match)


#############################################
# Function: decode_link_control
#############################################
def decode_link_control(tsbk,fout,date_time):
	global check_var

	p = (int(tsbk[0*2+0:0*2+2],16) >> 7) & 1
	sf = (int(tsbk[0*2+0:0*2+2],16) >> 6) & 1
	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0
	
	if (opcode == 0x00) and (sf == 0):	#GRP_V_USR
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		grp_addr = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nGRP_V_USR opcode(hex)=%x\np=%d sf=%d manuf_id=%d serv_opt=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,manuf_id,serv_opt,grp_addr,src_addr)
	
	if (opcode == 0x02) and (sf == 1):	#GRP_V_UPDT
		found = 1
		chan_a = 256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)
		grp_addr_a = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		chan_b = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		grp_addr_b = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nGRP_V_UPDT opcode(hex)=%x\np=%d sf=%d chan_a=%d grp_addr_a=%d chan_b=%d grp_addr_b=%d\n' % \
			(date_time,opcode,p,sf,chan_a,grp_addr_a,chan_b,grp_addr_b)
	
	if (opcode == 0x03) and (sf == 0):	#U2U_V_USR
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nU2U_V_USR opcode(hex)=%x\np=%d sf=%d manuf_id=%d serv_opt=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,manuf_id,serv_opt,targ_addr,src_addr)
	
	if (opcode == 0x04) and (sf == 1):	#GRP_V_UPDT_EXP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		grp_addr = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		chan_tx = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		chan_rx = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nGRP_V_UPDT_EXP opcode(hex)=%x\np=%d sf=%d serv_opt=%d grp_addr=%d chan_tx=%d chan_rx=%d\n' % \
			(date_time,opcode,p,sf,serv_opt,grp_addr,chan_tx,chan_rx)
	
	if (opcode == 0x05) and (sf == 1):	#U2U_ANS_REQ
		found = 1
		serv_opt = int(tsbk[1*2+0:1*2+2],16)
		s = int(tsbk[2*2+0:2*2+2],16) & 0x1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nU2U_ANS_REQ opcode(hex)=%x\np=%d sf=%d serv_opt=%d s=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,serv_opt,s,targ_addr,src_addr)
	
	if (opcode == 0x06) and (sf == 1):	#TEL_V_USR
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		call_timer = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		src_targ_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nTEL_V_USR opcode(hex)=%x\np=%d sf=%d serv_opt=%d call_timer=%d src_targ_addr=%d\n' % \
			(date_time,opcode,p,sf,serv_opt,call_timer,src_targ_addr)
	
	if (opcode == 0x07) and (sf == 1):	#TEL_ANS_REQ
		found = 1
		digits = tsbk[1*2+0:1*2+10]
		targ_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nTEL_ANS_REQ opcode(hex)=%x\np=%d sf=%d digits=%s targ_addr=%d\n' % \
			(date_time,opcode,p,sf,digits,targ_addr)
		
	if (opcode == 0x0f) and (sf == 1):	#CALL_TERM
		found = 1
		src_targ_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nCALL_TERM opcode(hex)=%x\np=%d sf=%d src_targ_addr=%d\n' % \
			(date_time,opcode,p,sf,src_targ_addr)

	if (opcode == 0x10) and (sf == 1):	#GRP_AFF_QUE
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nGRP_AFF_QUE opcode(hex)=%x\np=%d sf=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,targ_addr,src_addr)
	
	if (opcode == 0x11) and (sf == 1):	#U_REG_CMD
		found = 1
		net_id = (256*(256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)) + int(tsbk[3*2+0:3*2+2],16)) >> 4
		sys_id = (256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) + int(tsbk[7*2+0:7*2+2],16)
		st = '%s\nU_REG_CMD opcode(hex)=%x\np=%d sf=%d net_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,p,sf,net_id,sys_id,src_id)
	
	if (opcode == 0x12) and (sf == 1):	#U_AUTH_CMD
		found = 1
		net_id = (256*(256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)) + int(tsbk[3*2+0:3*2+2],16)) >> 4
		sys_id = (256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) + int(tsbk[7*2+0:7*2+2],16)
		st = '%s\nU_AUTH_CMD opcode(hex)=%x\np=%d sf=%d net_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,p,sf,net_id,sys_id,targ_id)
	
	if (opcode == 0x13) and (sf == 1):	#STAT_QUE
		found = 1
		s = int(tsbk[2*2+0:2*2+2],16) & 0x1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nSTAT_QUE opcode(hex)=%x\np=%d sf=%d s=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,s,targ_addr,src_addr)
	
	if (opcode == 0x20) and (sf == 1):	#SYS_SRV_BCST
		found = 1
		prior = int(tsbk[2*2+0:2*2+2],16) & 0xf
		serv_avail = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_supp = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nSYS_SRV_BCST opcode(hex)=%x\np=%d sf=%d prior=%d serv_avail=%d serv_supp=%d\n' % \
			(date_time,opcode,p,sf,prior,serv_avail,serv_supp)
	
	if (opcode == 0x21) and (sf == 1):	#SEC_CTL_CH_BCST
		found = 1
		rf_subsys_id = int(tsbk[1*2+0:1*2+2],16)
		site_id = int(tsbk[2*2+0:2*2+2],16)
		chan_a = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		serv_class_a = int(tsbk[5*2+0:5*2+2],16)
		chan_b = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		serv_class_b = int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nSEC_CTL_CH_BCST opcode(hex)=%x\np=%d sf=%d rf_subsys_id=%d site_id=%d chan_a=%d serv_class_a(hex)=%x chan_b=%d serv_class_b(hex)=%x\n' % \
			(date_time,opcode,p,sf,rf_subsys_id,site_id,chan_a,serv_class_a,chan_b,serv_class_b)
	
	if (opcode == 0x22) and (sf == 1):	#ADJ_STAT_BCST
		found = 1
		loc_reg_area = int(tsbk[1*2+0:1*2+2],16)
		sys_id = (256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) & 0xfff
		rf_subsys_id = int(tsbk[4*2+0:4*2+2],16)
		site_id = int(tsbk[5*2+0:5*2+2],16)
		chan = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		serv_class = int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nADJ_STAT_BCST opcode(hex)=%x\np=%d sf=%d loc_reg_area=%d sys_id=%d rf_subsys_id=%d site_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,p,sf,loc_reg_area,sys_id,rf_subsys_id,site_id,chan,serv_class)
	
	if (opcode == 0x23) and (sf == 1):	#RFSS_STAT_BCST
		found = 1
		loc_reg_area = int(tsbk[1*2+0:1*2+2],16)
		sys_id = (256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) & 0xfff
		rf_subsys_id = int(tsbk[4*2+0:4*2+2],16)
		site_id = int(tsbk[5*2+0:5*2+2],16)
		chan = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		serv_class = int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nRFSS_STAT_BCST opcode(hex)=%x\np=%d sf=%d loc_reg_area=%d sys_id=%d rf_subsys_id=%d site_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,p,sf,loc_reg_area,sys_id,rf_subsys_id,site_id,chan,serv_class)
	
	if (opcode == 0x24) and (sf == 1):	#NET_STAT_BCST
		found = 1
		net_id = (256*(256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) + int(tsbk[4*2+0:4*2+2],16)) >> 4
		sys_id = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0xfff
		chan = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		serv_class = int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nNET_STAT_BCST opcode(hex)=%x\np=%d sf=%d net_id=%d sys_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,p,sf,net_id,sys_id,chan,serv_class)
	
	if (opcode == 0x14) and (sf == 1):	#STAT_UPDT
		found = 1
		stat = 256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nSTAT_UPDT opcode(hex)=%x\np=%d sf=%d stat=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,stat,targ_addr,src_addr)
	
	if (opcode == 0x15) and (sf == 1):	#MSG_UPDT
		found = 1
		msg = 256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nMSG_UPDT opcode(hex)=%x\np=%d sf=%d msg=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,msg,targ_addr,src_addr)
	
	if (opcode == 0x16) and (sf == 1):	#CALL_ALRT
		found = 1
		s = int(tsbk[2*2+0:2*2+2],16) & 0x1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nCALL_ALRT opcode(hex)=%x\np=%d sf=%d manuf_id=%d s=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,p,sf,manuf_id,s,targ_addr,src_addr)
	
	if (opcode == 0x17) and (sf == 1):	#EXT_FUN_CMD
		found = 1
		ext_func = tsbk[1*2+0:1*2+10]
		targ_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nEXT_FUN_CMD opcode(hex)=%x\np=%d sf=%d ext_func=%s targ_addr=%d\n' % \
			(date_time,opcode,p,sf,ext_func,targ_addr)
	
	if (opcode == 0x18) and (sf == 1):	#CH_IDEN_UPDT
		found = 1
		chan_ident = int(tsbk[1*2+0:1*2+2],16) >> 4
		bw = ((256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)) >> 3) & 0x1ff
		tran_off = ((256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) >> 2) & 0x0ff
		tran_off_sgn = ((256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) >> 10) & 1
		chan_spac = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 0) & 0x3ff
		base_freq = 256*(256*(256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		
		if (tran_off_sgn == 0):
			tran_off = -tran_off

		st = '%s\nCH_IDEN_UPDT opcode(hex)=%x\np=%d sf=%d chan_ident=%d bw(Hz)=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(Hz)=%d\n' % \
			(date_time,opcode,p,sf,chan_ident,bw*125,tran_off*250000,chan_spac*125,base_freq*5)
	
	if (opcode == 0x25) and (sf == 1):	#PRT_PARM_BCST
		found = 1
		alg_id = int(tsbk[3*2+0:3*2+2],16)
		key_id = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		targ_addr = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nPRT_PARM_BCST opcode(hex)=%x\np=%d sf=%d alg_id=%d key_id=%d targ_addr=%d\n' % \
			(date_time,opcode,p,sf,alg_id,key_id,targ_addr)
	
	if (opcode == 0x26) and (sf == 1):	#SEC_CTL_CH_BCST
		found = 1
		rf_subsys_id = int(tsbk[1*2+0:1*2+2],16)
		site_id = int(tsbk[2*2+0:2*2+2],16)
		chan_tx = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		chan_rx = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		serv_class = int(tsbk[7*2+0:7*2+2],16)
		st = '%s\nSEC_CTL_CH_BCST opcode(hex)=%x\np=%d sf=%d rf_subsys_id=%d site_id=%d chan_tx=%d chan_rx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,p,sf,rf_subsys_id,site_id,chan_tx,chan_rx,serv_class)
	
	if (opcode == 0x27) and (sf == 1):	#ADJ_STAT_BCST
		found = 1
		lra = int(tsbk[1*2+0:1*2+2],16)
		chan_tx = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		rf_subsys_id = int(tsbk[4*2+0:4*2+2],16)
		site_id = int(tsbk[5*2+0:5*2+2],16)
		chan_rx = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		c = (int(tsbk[8*2+0:8*2+2],16) >> 7) & 1
		f = (int(tsbk[8*2+0:8*2+2],16) >> 6) & 1
		v = (int(tsbk[8*2+0:8*2+2],16) >> 5) & 1
		a = (int(tsbk[8*2+0:8*2+2],16) >> 4) & 1
		st = '%s\nADJ_STAT_BCST opcode(hex)=%x\np=%d sf=%d lra=%d chan_tx=%d rf_subsys_id=%d site_id=%d chan_rx=%d c=%d f=%d v=%d a=%d\n' % \
			(date_time,opcode,p,sf,lra,chan_tx,rf_subsys_id,site_id,chan_rx,c,f,v,a)
	
	if (opcode == 0x19) and (sf == 1):	#CH_IDEN_UPDT_VU
		found = 1
		chan_ident = int(tsbk[1*2+0:1*2+2],16) >> 4
		bw = int(tsbk[1*2+0:1*2+2],16) & 0xf
		tran_off = ((256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) >> 2) & 0x1fff
		tran_off_sgn = ((256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) >> 15) & 1
		chan_spac = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 0) & 0x3ff
		base_freq = 256*(256*(256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)

		if (tran_off_sgn == 0):
			tran_off = -tran_off

		st = '%s\nCH_IDEN_UPDT_VU opcode(hex)=%x\np=%d sf=%d chan_ident=%d bw(Hz)=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(Hz)=%d\n' % \
			(date_time,opcode,p,sf,chan_ident,bw*125,tran_off*chan_spac*125,chan_spac*125,base_freq*5)
	
	if (opcode == 0x28) and (sf == 1):	#RFSS_STAT_BCST
		found = 1
		lra = int(tsbk[1*2+0:1*2+2],16)
		chan_rx = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		rf_subsys_id = int(tsbk[4*2+0:4*2+2],16)
		site_id = int(tsbk[5*2+0:5*2+2],16)
		chan_tx = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		serv_class = int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nRFSS_STAT_BCST opcode(hex)=%x\np=%d sf=%d lra=%d chan_rx=%d rf_subsys_id=%d site_id=%d chan_tx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,p,sf,lra,chan_rx,rf_subsys_id,site_id,chan_tx,serv_class)
		
	if (opcode == 0x29) and (sf == 1):	#NET_STAT_BCST
		found = 1
		net_id = (256*(256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)) + int(tsbk[3*2+0:3*2+2],16)) >> 4
		sys_id = (256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) & 0xfff
		chan_tx = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		chan_rx = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nNET_STAT_BCST opcode(hex)=%x\np=%d sf=%d net_id=%d sys_id=%d chan_tx=%d chan_rx=%d\n' % \
			(date_time,opcode,p,sf,net_id,sys_id,chan_tx,chan_rx)
	
	if (opcode == 0x0a) and (sf == 1):	#U2U_V_USR_EXT
		found = 1
		s = int(tsbk[1*2+0:1*2+2],16) & 0x1
		serv_opt = int(tsbk[2*2+0:2*2+2],16) & 0x1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_id = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nU2U_V_USR_EXT opcode(hex)=%x\np=%d sf=%d s=%d serv_opt=%d targ_addr=%d src_id=%d\n' % \
			(date_time,opcode,p,sf,s,serv_opt,targ_addr,src_id)
	
	if (opcode == 0x1b) and (sf == 1):	#MSG_UPDT_EXT
		found = 1
		msg = 256*int(tsbk[1*2+0:1*2+2],16) + int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		src_id = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nMSG_UPDT_EXT opcode(hex)=%x\np=%d sf=%d msg=%d targ_addr=%d src_id=%d\n' % \
			(date_time,opcode,p,sf,msg,targ_addr,src_id)
	
	if (opcode == 0x09) and (sf == 1):	#SRC_ID_EXT
		found = 1
		net_id = (256*(256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) + int(tsbk[4*2+0:4*2+2],16)) >> 4
		sys_id = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nSRC_ID_EXT opcode(hex)=%x\np=%d sf=%d net_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,p,sf,net_id,sys_id,src_id)
	
	if (opcode == 0x1c) and (sf == 1):	#EXT_FUN_CMD_EXT
		found = 1
		ext_func = tsbk[1*2+0:1*2+10]
		targ_id = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		st = '%s\nEXT_FUN_CMD_EXT opcode(hex)=%x\np=%d sf=%d ext_func=%s targ_id=%d\n' % \
			(date_time,opcode,p,sf,ext_func,targ_id)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_voice_service_isp_single
#############################################
def decode_voice_service_isp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0

	if (opcode == 0x00) and (manuf_id == 0):	#GRP_V_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_V_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,grp_addr,src_addr)

	if (opcode == 0x04) and (manuf_id == 0):	#UU_V_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		targ_id = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nUU_V_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d targ_id=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,targ_id,src_addr)
		
	if (opcode == 0x05) and (manuf_id == 0):	#UU_ANS_RSP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		answer = int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nUU_ANS_RSP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d answer=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,answer,targ_addr,src_addr)
		
	if (opcode == 0x09) and (manuf_id == 0):	#TELE_INT_PSTN_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		pstn_addr = int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nTELE_INT_PSTN_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d pstn_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,pstn_addr,src_addr)
		
	if (opcode == 0x0a) and (manuf_id == 0):	#TELE_INT_ANS_RSP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		answer = int(tsbk[3*2+0:3*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nTELE_INT_ANS_RSP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d answer=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,answer,src_addr)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_data_service_isp_single
#############################################
def decode_data_service_isp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0

	if (opcode == 0x10) and (manuf_id == 0):	#IND_DATA_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nIND_DATA_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,targ_addr,src_addr)
		
	if (opcode == 0x11) and (manuf_id == 0):	#GRP_DATA_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_DATA_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,grp_addr,src_addr)
	
	if (opcode == 0x12) and (manuf_id == 0):	#SN_DATA_CHN_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		access_ctrl = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSN_DATA_CHN_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d access_ctrl=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,access_ctrl,src_addr)
	
	if (opcode == 0x13) and (manuf_id == 0):	#SN_DATA_PAGE_RES
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		answer_resp = int(tsbk[3*2+0:3*2+2],16)
		access_ctrl = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSN_DATA_PAGE_RES opcode(hex)=%x\nmanuf_id=%d serv_opt=%d answer_resp=%d access_ctrl=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,answer_resp,access_ctrl,src_addr)
	
	if (opcode == 0x14) and (manuf_id == 0):	#SN_REC_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		access_ctrl = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		ds = (int(tsbk[5*2+0:5*2+2],16) >> 7) & 0x01
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSN_REC_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d access_ctrl=%d ds=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,access_ctrl,ds,src_addr)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_control_status_isp_single
#############################################
def decode_control_status_isp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0
		
	if (opcode == 0x20) and (manuf_id == 0):	#ACK_RSP_U
		found = 1
		serv_type = int(tsbk[2*2+0:2*2+2],16) & 0x3f
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nACK_RSP_U opcode(hex)=%x\nmanuf_id=%d serv_type=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_type,targ_addr,src_addr)
		
	if (opcode == 0x2e) and (manuf_id == 0):	#AUTH_Q
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_Q opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)
		
	if (opcode == 0x1f) and (manuf_id == 0):	#CALL_ALRT_REQ
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nCALL_ALRT_REQ opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)
		
	if (opcode == 0x23) and (manuf_id == 0):	#CAN_SRV_REQ
		found = 1
		serv_type = int(tsbk[2*2+0:2*2+2],16) & 0x3f
		aiv = int(tsbk[2*2+0:2*2+2],16) >> 6
		reason = int(tsbk[3*2+0:3*2+2],16)
		info = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nCAN_SRV_REQ opcode(hex)=%x\nmanuf_id=%d serv_type=%d aiv=%d reason=%d info=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_type,aiv,reason,info,src_addr)
		
	if (opcode == 0x27) and (manuf_id == 0):	#EMRG_ALRM_REQ
		found = 1
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nEMRG_ALRM_REQ opcode(hex)=%x\nmanuf_id=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,grp_addr,src_addr)
		
	if (opcode == 0x24) and (manuf_id == 0):	#EXT_FNCT_RSP
		found = 1
		b1 = int(tsbk[2*2+0:2*2+2],16)
		b2 = int(tsbk[3*2+0:3*2+2],16)
		b3 = int(tsbk[4*2+0:4*2+2],16)
		b4 = int(tsbk[5*2+0:5*2+2],16)
		b5 = int(tsbk[6*2+0:6*2+2],16)
		ext_func = 256*(256*(256*(256*b1 + b2) + b3) + b4) + b5
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nEXT_FNCT_RSP opcode(hex)=%x\nmanuf_id=%d ext_func=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,ext_func,src_addr)
		
	if (opcode == 0x29) and (manuf_id == 0):	#GRP_AFF_Q_RSP
		found = 1
		e = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x1
		ann_grp_addr = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_AFF_Q_RSP opcode(hex)=%x\nmanuf_id=%d e=%d ann_grp_addr=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,e,ann_grp_addr,grp_addr,src_addr)
		
	if (opcode == 0x28) and (manuf_id == 0):	#GRP_AFF_REQ
		found = 1
		e = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x1
		sys_id = (256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) & 0xfff
		grp_id = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_AFF_REQ opcode(hex)=%x\nmanuf_id=%d e=%d sys_id=%d grp_id=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,e,sys_id,grp_id,src_addr)
		
	if (opcode == 0x32) and (manuf_id == 0):	#IDEN_UP_REQ
		found = 1
		flags = int(tsbk[2*2+0:2*2+2],16) >> 4
		ident = int(tsbk[2*2+0:2*2+2],16) & 0xf
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nIDEN_UP_REQ opcode(hex)=%x\nmanuf_id=%d flags=%d ident=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,flags,ident,src_addr)
		
	if (opcode == 0x1c) and (manuf_id == 0):	#MSG_UPDT_REQ
		found = 1
		msg = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nMSG_UPDT_REQ opcode(hex)=%x\nmanuf_id=%d msg=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,msg,targ_addr,src_addr)
		
	if (opcode == 0x30) and (manuf_id == 0):	#P_PARM_REQ
		found = 1
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nP_PARM_REQ opcode(hex)=%x\nmanuf_id=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,wacn_id,sys_id,src_id)
		
	if (opcode == 0x1a) and (manuf_id == 0):	#STS_Q_REQ
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSTS_Q_REQ opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)
		
	if (opcode == 0x19) and (manuf_id == 0):	#STS_Q_RSP
		found = 1
		status = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSTS_Q_RSP opcode(hex)=%x\nmanuf_id=%d status=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,status,targ_addr,src_addr)
		
	if (opcode == 0x18) and (manuf_id == 0):	#STS_UPDT_REQ
		found = 1
		status = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSTS_UPDT_REQ opcode(hex)=%x\nmanuf_id=%d status=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,status,targ_addr,src_addr)
		
	if (opcode == 0x2c) and (manuf_id == 0):	#U_REG_REQ
		found = 1
		e = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x01
		capab = int(tsbk[2*2+0:2*2+2],16) & 0x7f
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nU_REG_REQ opcode(hex)=%x\nmanuf_id=%d e=%d capab=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,e,capab,wacn_id,sys_id,src_id)
		
	if (opcode == 0x2b) and (manuf_id == 0):	#U_DE_REG_REQ
		found = 1
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nU_DE_REG_REQ opcode(hex)=%x\nmanuf_id=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,wacn_id,sys_id,src_id)
		
	if (opcode == 0x2d) and (manuf_id == 0):	#LOC_REG_REQ
		found = 1
		e = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x01
		capab = int(tsbk[2*2+0:2*2+2],16) & 0x7f
		lra = int(tsbk[4*2+0:4*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nLOC_REG_REQ opcode(hex)=%x\nmanuf_id=%d e=%d capab=%d lra=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,e,capab,lra,grp_addr,src_addr)
		
	if (opcode == 0x1d) and (manuf_id == 0):	#RAD_MON_REQ
		found = 1
		tx_time = int(tsbk[2*2+0:2*2+2],16)
		sm = (int(tsbk[3*2+0:3*2+2],16) >> 7) & 0x1
		tx_mult = int(tsbk[3*2+0:3*2+2],16) & 0x3
		targ_id = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nRAD_MON_REQ opcode(hex)=%x\nmanuf_id=%d tx_time=%d sm=%d tx_mult=%d targ_id=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,tx_time,sm,tx_mult,targ_id,src_addr)
		
	if (opcode == 0x36) and (manuf_id == 0):	#ROAM_ADDR_REQ
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nROAM_ADDR_REQ opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)
		
	if (opcode == 0x37) and (manuf_id == 0):	#ROAM_ADDR_RSP
		found = 1
		lm = int(tsbk[2*2+0:2*2+2],16) >> 7
		msn = int(tsbk[2*2+0:2*2+2],16) & 0xf
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nROAM_ADDR_RSP opcode(hex)=%x\nmanuf_id=%d lm=%d msn=%d wacn_id=%d sys_id=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,lm,msn,wacn_id,sys_id,src_addr)
		
	if (opcode == 0x3a) and (manuf_id == 0):	#AUTH_FNE_RST
		found = 1
		r2 = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x1
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_FNE_RST opcode(hex)=%x\nmanuf_id=%d r2=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,r2,src_id)
		
	if (opcode == 0x38) and (manuf_id == 0):	#AUTH_RESP
		found = 1
		res1 = tsbk[2*2+0:2*2+8]
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_RESP opcode(hex)=%x\nmanuf_id=%d res1=%s src_id=%d\n' % \
			(date_time,opcode,manuf_id,res1,src_id)
		
	if (opcode == 0x3b) and (manuf_id == 0):	#AUTH_SU_DMD
		found = 1
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_SU_DMD opcode(hex)=%x\nmanuf_id=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,src_id)

	if (found):	
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_voice_service_isp_mult
#############################################
def decode_voice_service_isp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	blks_to_follow = int(tsbk[6*2+0:6*2+2],16) & 0x7f
	found = 0
	
	if (opcode == 0x04) and (manuf_id == 0):	#UU_V_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[13*2+0:13*2+2],16) + int(tsbk[14*2+0:14*2+2],16)) + int(tsbk[15*2+0:15*2+2],16)) >> 4
		sys_id = (256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nUU_V_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x05) and (manuf_id == 0):	#UU_ANS_RSP
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		answer_resp = int(tsbk[9*2+0:9*2+2],16)
		wacn_id = (256*(256*int(tsbk[13*2+0:13*2+2],16) + int(tsbk[14*2+0:14*2+2],16)) + int(tsbk[15*2+0:15*2+2],16)) >> 4
		sys_id = (256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nUU_ANS_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d answer_resp=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,answer_resp,wacn_id,sys_id,targ_id)
	
	pad_oct_cnt = int(tsbk[12*2+0:12*2+2],16) & 0x1f
	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	if (opcode == 0x08) and (manuf_id == 0) and (pad_oct_cnt == 0):	#TELE_INT_DIAL_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		data_head_off = int(tsbk[9*2+0:9*2+2],16) & 0x3f
		digit_cnt = int(tsbk[13*2+0:13*2+2],16)
		serv_opt = int(tsbk[14*2+0:14*2+2],16)

		if (blks_to_follow == 1):
			digits = tsbk[15*2+0:15*2+10]
		else:
			digits = tsbk[15*2+0:15*2+34]

		st = '%s\nTELE_INT_DIAL_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d digit_cnt=%d serv_opt=%d digits=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,digit_cnt,serv_opt,digits)

	if (found):	
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)

#############################################
# Function: decode_data_service_isp_mult
#############################################
def decode_data_service_isp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	found = 0
	
	if (opcode == 0x10) and (manuf_id == 0):	#IND_DATA_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nIND_DATA_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,wacn_id,sys_id,targ_id)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_control_status_isp_mult
#############################################
def decode_control_status_isp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	found = 0
	
	if (opcode == 0x20) and (manuf_id == 0):	#ACK_RSP_U
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_type = int(tsbk[8*2+0:8*2+2],16) & 0x3f
		wacn_id = (256*(256*int(tsbk[9*2+0:9*2+2],16) + int(tsbk[12*2+0:12*2+2],16)) + int(tsbk[13*2+0:13*2+2],16)) >> 4
		sys_id = (256*int(tsbk[13*2+0:13*2+2],16) + int(tsbk[14*2+0:14*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)) + int(tsbk[17*2+0:17*2+2],16)
		st = '%s\nACK_RSP_U opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_type=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_type,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x2e) and (manuf_id == 0):	#AUTH_Q
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nAUTH_Q opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x2f) and (manuf_id == 0):	#AUTH_RSP
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		auth = tsbk[17*2+0,17*2+16]
		st = '%s\nAUTH_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d auth(hex)=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id,auth)
	
	if (opcode == 0x1f) and (manuf_id == 0):	#CALL_ALRT_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nCALL_ALRT_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x23) and (manuf_id == 0):	#CAN_SRV_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		aiv = (int(tsbk[8*2+0:8*2+2],16) >> 7) & 0x1
		serv_type = int(tsbk[8*2+0:8*2+2],16) & 0x3f
		reason = int(tsbk[9*2+0:9*2+2],16)
		wacn_id = (256*(256*int(tsbk[13*2+0:13*2+2],16) + int(tsbk[14*2+0:14*2+2],16)) + int(tsbk[15*2+0:15*2+2],16)) >> 4
		sys_id = (256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)) & 0xfff
		unit_id = 256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nCAN_SRV_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d aiv=%d serv_type=%d reason=%d wacn_id=%d sys_id=%d unit_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,aiv,serv_type,reason,wacn_id,sys_id,unit_id)
	
	if (opcode == 0x24) and (manuf_id == 0):	#EXT_FNCT_RSP
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		ext_func = tsbk[14*2+0:14*2+10]
		st = '%s\nEXT_FNCT_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d ext_func=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,ext_func)
	
	if (opcode == 0x28) and (manuf_id == 0):	#GRP_AFF_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		grp_id = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		e = (int(tsbk[16*2+0:16*2+2],16) >> 7) & 0x1
		st = '%s\nGRP_AFF_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d grp_id=%d e=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,grp_id,e)
	
	if (opcode == 0x1c) and (manuf_id == 0):	#MSG_UPDT_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		msg = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nMSG_UPDT_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d msg=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,msg,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x1a) and (manuf_id == 0):	#STS_Q_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nSTS_Q_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x19) and (manuf_id == 0):	#STS_Q_RSP
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		status = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nSTS_Q_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d status=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,status,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x18) and (manuf_id == 0):	#STS_UPDT_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		status = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nSTS_UPDT_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d status=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,status,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x2d) and (manuf_id == 0):	#LOC_REG_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		prev_lra = int(tsbk[17*2+0:17*2+2],16)
		grp_addr = 256*int(tsbk[18*2+0:18*2+2],16) + int(tsbk[19*2+0:19*2+2],16)
		e = (int(tsbk[20*2+0:20*2+2],16) >> 7) & 0x1
		capab = int(tsbk[20*2+0:20*2+2],16) & 0x7f
		st = '%s\nLOC_REG_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d src_id=%d prev_lra=%d grp_addr=%d e=%d capab=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,src_id,prev_lra,grp_addr,e,capab)
	
	if (opcode == 0x1d) and (manuf_id == 0):	#RAD_MON_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		tx_time = int(tsbk[18*2+0:18*2+2],16)
		sm = (int(tsbk[19*2+0:19*2+2],16) >> 7) & 0x1
		tx_mult = int(tsbk[19*2+0:19*2+2],16) & 0x7f
		st = '%s\nRAD_MON_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d targ_id=%d tx_time=%d sm=%d e=%d tx_mult=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,targ_id,tx_time,sm,tx_mult)
	
	if (opcode == 0x36) and (manuf_id == 0):	#ROAM_ADDR_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nROAM_ADDR_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,targ_id)
	
	if (opcode == 0x37) and (manuf_id == 0):	#ROAM_ADDR_UPDT
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		blks = (int(tsbk[6*2+0:6*2+2],16) & 0x7f) - 1
		lm = int(tsbk[8*2+0:8*2+2],16) >> 7
		msn = int(tsbk[8*2+0:8*2+2],16) & 0xf
		wacn_sys_id = tsbk[9*2+0:9*2+2] + tsbk[12*2+0:12*2+((blks*24)+14)]
		st = '%s\nROAM_ADDR_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d lm=%d msn=%d wacn_sys_id(hex)=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,lm,msn,wacn_sys_id)
	
	if (opcode == 0x3a) and (manuf_id == 0):	#AUTH_FNE_RST
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		r2 = (int(tsbk[17*2+0:17*2+2],16) >> 7) & 0x1
		st = '%s\nAUTH_FNE_RST opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d src_id=%d r2=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,src_id,r2)
	
	if (opcode == 0x38) and (manuf_id == 0):	#AUTH_RESP
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		res1 = tsbk[17*2+0:17*2+8]
		st = '%s\nAUTH_RESP opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d src_id=%d res1=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,src_id,res1)
	
	if (opcode == 0x39) and (manuf_id == 0):	#AUTH_RESP_M
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		rand2 = tsbk[17*2+0:17*2+10]
		res1 = tsbk[22*2+0:22*2+8]
		st = '%s\nAUTH_RESP_M opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d src_id=%d rand2=%s res1=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,src_id,rand2,res1)
	
	if (opcode == 0x3b) and (manuf_id == 0):	#AUTH_SU_DMD
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nAUTH_SU_DMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id,sys_id,src_id)
	
	if (opcode == 0x1e) and (manuf_id == 0) and (blks_to_follow == 1):	#RAD_MON_ENH_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		grp_id = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		targ_addr = 256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)
		sm = (int(tsbk[15*2+0:15*2+2],16) >> 7) & 0x1
		tg = (int(tsbk[15*2+0:15*2+2],16) >> 6) & 0x1
		tx_time = int(tsbk[16*2+0:16*2+2],16)
		key_id = 256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)
		alg_id = int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nRAD_MON_ENH_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d grp_id=%d targ_addr=%d sm=%d tg=%d tx_time=%d key_id=%d alg_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,grp_id,targ_addr,sm,tg,tx_time,key_id,alg_id)
	
	if (opcode == 0x1e) and (manuf_id == 0) and (blks_to_follow == 2):	#RAD_MON_ENH_REQ
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id_targ = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id_targ = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		wacn_id_grp = (256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)) >> 4
		sys_id_grp = (256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)) & 0xfff
		grp_id = 256*int(tsbk[21*2+0:21*2+2],16) + int(tsbk[22*2+0:22*2+2],16)
		sm = (int(tsbk[23*2+0:23*2+2],16) >> 7) & 0x1
		tg = (int(tsbk[23*2+0:23*2+2],16) >> 6) & 0x1
		tx_time = int(tsbk[24*2+0:24*2+2],16)
		key_id = 256*int(tsbk[25*2+0:25*2+2],16) + int(tsbk[26*2+0:26*2+2],16)
		alg_id = int(tsbk[27*2+0:27*2+2],16)
		st = '%s\nRAD_MON_ENH_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d wacn_id_targ=%d sys_id_targ=%d targ_id=%d wacn_id_grp=%d sys_id_grp=%d grp_id=%d sm=%d tg=%d tx_time=%d key_id=%d alg_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,wacn_id_targ,sys_id_targ,targ_id,wacn_id_grp,sys_id_grp,grp_id,sm,tg,tx_time,key_id,alg_id)

	if (found):	
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_voice_service_osp_single
#############################################
def decode_voice_service_osp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0
		
	if (opcode == 0x00) and (manuf_id == 0):	#GRP_V_CH_GRANT
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_V_CH_GRANT opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan,grp_addr,src_addr)

	if (opcode == 0x02) and (manuf_id == 0):	#GRP_V_CH_GRANT_UPDT
		found = 1
		chan1 = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		grp_addr1 = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan2 = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		grp_addr2 = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_V_CH_GRANT_UPDT opcode(hex)=%x\nmanuf_id=%d chan1=%d grp_addr1=%d chan2=%d grp_addr2=%d\n' % \
			(date_time,opcode,manuf_id,chan1,grp_addr1,chan2,grp_addr2)

	if (opcode == 0x03) and (manuf_id == 0):	#GRP_V_CH_GRANT_UPDT_EXP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan_tx = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan_rx = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		grp_addr = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_V_CH_GRANT_UPDT_EXP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan_tx=%d chan_rx=%d grp_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan_tx,chan_rx,grp_addr)
		
	if (opcode == 0x05) and (manuf_id == 0):	#UU_ANS_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nUU_ANS_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d targ_addr=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,targ_addr,src_id)
		
	if (opcode == 0x04) and (manuf_id == 0):	#UU_V_CH_GRANT
		found = 1
		chan = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nUU_V_CH_GRANT opcode(hex)=%x\nmanuf_id=%d chan=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,chan,targ_addr,src_addr)
		
	if (opcode == 0x08) and (manuf_id == 0):	#TELE_INT_CH_GRANT
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		call_timer = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nTELE_INT_CH_GRANT opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan=%d call_timer=%d targ_src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan,call_timer,targ_src_addr)
		
	if (opcode == 0x0a) and (manuf_id == 0):	#TELE_INT_ANS_REQ
		found = 1
		digits = tsbk[2*2+0:2*2+10]
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nTELE_INT_ANS_REQ opcode(hex)=%x\nmanuf_id=%d digits=%s targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,digits,targ_addr)
		
	if (opcode == 0x06) and (manuf_id == 0):	#UU_V_CH_GRANT_UPDT
		found = 1
		chan = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nUU_V_CH_GRANT_UPDT opcode(hex)=%x\nmanuf_id=%d chan=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,chan,targ_addr,src_addr)
		
	if (opcode == 0x09) and (manuf_id == 0):	#TELE_INT_CH_GRANT_UPDT
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		call_timer = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nTELE_INT_CH_GRANT_UPDT opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan=%d call_timer=%d targ_src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan,call_timer,targ_src_addr)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_data_service_osp_single
#############################################
def decode_data_service_osp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0
		
	if (opcode == 0x10) and (manuf_id == 0):	#IND_DATA_CH_GRANT
		found = 1
		chan = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nIND_DATA_CH_GRANT opcode(hex)=%x\nmanuf_id=%d chan=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,chan,targ_addr,src_addr)
		
	if (opcode == 0x11) and (manuf_id == 0):	#GRP_DATA_CH_GRANT
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_DATA_CH_GRANT opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan=%d grp_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan,grp_addr,src_addr)
		
	if (opcode == 0x12) and (manuf_id == 0):	#GRP_DATA_CH_ANN
		found = 1
		chan1 = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		grp_addr1 = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan2 = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		grp_addr2 = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_DATA_CH_ANN opcode(hex)=%x\nmanuf_id=%d chan1=%d grp_addr1=%d chan2=%d grp_addr2=%d\n' % \
			(date_time,opcode,manuf_id,chan1,grp_addr1,chan2,grp_addr2)
		
	if (opcode == 0x13) and (manuf_id == 0):	#GRP_DATA_CH_ANN_EXP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan_tx = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan_rx = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		grp_addr = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_DATA_CH_ANN_EXP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan_tx=%d chan_rx=%d grp_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan_tx,chan_rx,grp_addr)
		
	if (opcode == 0x14) and (manuf_id == 0):	#GRP_DATA_CH_ANN_EXP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		chan_tx = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		chan_rx = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_DATA_CH_ANN_EXP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d chan_tx=%d chan_rx=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,chan_tx,chan_rx,targ_addr)
		
	if (opcode == 0x15) and (manuf_id == 0):	#SN_DATA_PAGE_REQ
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		access_ctrl = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSN_DATA_PAGE_REQ opcode(hex)=%x\nmanuf_id=%d serv_opt=%d access_ctrl=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,access_ctrl,targ_addr)
		
	if (opcode == 0x16) and (manuf_id == 0):	#SN_DATA_CHN_ANN_EXP
		found = 1
		serv_opt = int(tsbk[2*2+0:2*2+2],16)
		aa = (int(tsbk[3*2+0:3*2+2],16) >> 7) & 0x01
		ra = (int(tsbk[3*2+0:3*2+2],16) >> 6) & 0x01
		chan_tx = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan_rx = 256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)
		access_ctrl = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSN_DATA_CHN_ANN_EXP opcode(hex)=%x\nmanuf_id=%d serv_opt=%d aa=%d ra=%d chan_tx=%d chan_rx=%d access_ctrl=%d\n' % \
			(date_time,opcode,manuf_id,serv_opt,aa,ra,chan_tx,chan_rx,access_ctrl)

	if (found):	
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_control_status_osp_single
#############################################
def decode_control_status_osp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	found = 0
		
	if (opcode == 0x20) and (manuf_id == 0):	#ACK_RSP_FNE
		found = 1
		aiv = (int(tsbk[2*2+0:2*2+2],16) >> 7) & 0x1
		ex = (int(tsbk[2*2+0:2*2+2],16) >> 6) & 0x1
		serv_type = int(tsbk[2*2+0:2*2+2],16) & 0x3f
		info = 256*(256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)

		if (aiv == 1):
			if (ex == 0):
				st = '%s\nACK_RSP_FNE opcode(hex)=%x\nmanuf_id=%d aiv=%d ex=%d serv_type=%d src_addr=%d targ_addr_id=%d\n' % \
					(date_time,opcode,manuf_id,aiv,ex,serv_type,src_addr,targ_addr_id)
			else:
				st = '%s\nACK_RSP_FNE opcode(hex)=%x\nmanuf_id=%d aiv=%d ex=%d serv_type=%d wacn_id=%d sys_id=%d targ_addr_id=%d\n' % \
					(date_time,opcode,manuf_id,aiv,ex,serv_type,wacn_id,sys_id,targ_addr_id)
		else:
			st = '%s\nACK_RSP_FNE opcode(hex)=%x\nmanuf_id=%d aiv=%d ex=%d serv_type=%d info=%d targ_addr_id=%d\n' % \
				(date_time,opcode,manuf_id,aiv,ex,serv_type,info,targ_addr_id)

	if (opcode == 0x3c) and (manuf_id == 0):	#ADJ_STS_BCST
		found = 1
		lra = int(tsbk[2*2+0:2*2+2],16)
		c = (int(tsbk[3*2+0:3*2+2],16) >> 7) & 1
		f = (int(tsbk[3*2+0:3*2+2],16) >> 6) & 1
		v = (int(tsbk[3*2+0:3*2+2],16) >> 5) & 1
		a = (int(tsbk[3*2+0:3*2+2],16) >> 4) & 1
		sys_id = (256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) & 0xfff
		rf_subsys_id = int(tsbk[5*2+0:5*2+2],16)
		site_id = int(tsbk[6*2+0:6*2+2],16)
		chan = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		serv_class = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nADJ_STS_BCST opcode(hex)=%x\nmanuf_id=%d lra=%d c=%d f=%d v=%d a=%d sys_id=%d rf_subsys_id=%d site_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,lra,c,f,v,a,sys_id,rf_subsys_id,site_id,chan,serv_class)
		
	if (opcode == 0x2e) and (manuf_id == 0):	#AUTH_CMD
		found = 1
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_CMD opcode(hex)=%x\nmanuf_id=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,manuf_id,wacn_id,sys_id,targ_id)
		
	if (opcode == 0x1f) and (manuf_id == 0):	#CALL_ALRT
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nCALL_ALRT opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_id)
		
	if (opcode == 0x27) and (manuf_id == 0):	#DENY_RSP
		found = 1
		aiv = int(tsbk[2*2+0:2*2+2],16) >> 7
		serv_type = int(tsbk[2*2+0:2*2+2],16) & 0x3f
		reason = int(tsbk[3*2+0:3*2+2],16)
		info = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nDENY_RSP opcode(hex)=%x\nmanuf_id=%d aiv=%d serv_type=%d reason=%d info=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,aiv,serv_type,reason,info,targ_addr)
		
	if (opcode == 0x24) and (manuf_id == 0):	#EXT_FNCT_CMD
		found = 1
		b1 = int(tsbk[2*2+0:2*2+2],16)
		b2 = int(tsbk[3*2+0:3*2+2],16)
		b3 = int(tsbk[4*2+0:4*2+2],16)
		b4 = int(tsbk[5*2+0:5*2+2],16)
		b5 = int(tsbk[6*2+0:6*2+2],16)
		ext_func = 256*(256*(256*(256*b1 + b2) + b3) + b4) + b5
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nEXT_FNCT_CMD opcode(hex)=%x\nmanuf_id=%d ext_func=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,ext_func,targ_addr)
		
	if (opcode == 0x2a) and (manuf_id == 0):	#GRP_AFF_Q
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_AFF_Q opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)
		
	if (opcode == 0x28) and (manuf_id == 0):	#GRP_AFF_RSP
		found = 1
		lg = int(tsbk[2*2+0:2*2+2],16) >> 7
		gav = int(tsbk[2*2+0:2*2+2],16) & 0x3
		ann_grp_addr = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		grp_addr = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nGRP_AFF_RSP opcode(hex)=%x\nmanuf_id=%d lg=%d gav=%d ann_grp_addr=%d grp_addr=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,lg,gav,ann_grp_addr,grp_addr,targ_addr)
		
	if (opcode == 0x3d) and (manuf_id == 0):	#IDEN_UP
		found = 1
		ident = int(tsbk[2*2+0:2*2+2],16) >> 4
		b1 = int(tsbk[6*2+0:6*2+2],16)
		b2 = int(tsbk[7*2+0:7*2+2],16)
		b3 = int(tsbk[8*2+0:8*2+2],16)
		b4 = int(tsbk[9*2+0:9*2+2],16)
		base_freq = 256*(256*(256*b1 + b2) + b3) + b4

		if ((base_freq*5) < 136000000) or ((base_freq*5) > 512000000): 
			bw = ((256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) >> 3) & 0x1ff
			tran_off = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 2) & 0x0ff
			tran_off_sgn = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 10) & 1

			if (tran_off_sgn == 0):
				tran_off = -tran_off

			chan_spac = ((256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) >> 0) & 0x3ff
			st = '%s\nIDEN_UP opcode(hex)=%x\nmanuf_id=%d ident=%d bw(Hz)=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(Hz)=%d\n' % \
				(date_time,opcode,manuf_id,ident,bw*125,tran_off*250000,chan_spac*125,base_freq*5)
		else:
			bw = int(tsbk[2*2+0:2*2+2],16) & 0xf
			tran_off = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 2) & 0x1fff
			tran_off_sgn = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 15) & 1
			chan_spac = ((256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) >> 0) & 0x3ff
		
			if (bw == 4):
				bw = 6250
			else:
				if (bw == 5):
					bw = 12500
			if (tran_off_sgn == 0):
				tran_off = -tran_off
			st = '%s\nIDEN_UP opcode(hex)=%x\nmanuf_id=%d ident=%d bw(Hz)=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(Hz)=%d\n' % \
				(date_time,opcode,manuf_id,ident,bw,tran_off*chan_spac*125,chan_spac*125,base_freq*5)

	if (opcode == 0x34) and (manuf_id == 0):	#IDEN_UP_VU
		found = 1
		ident = int(tsbk[2*2+0:2*2+2],16) >> 4
		bw = int(tsbk[2*2+0:2*2+2],16) & 0xf
		tran_off = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 2) & 0x1fff
		tran_off_sgn = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 15) & 1
		chan_spac = ((256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) >> 0) & 0x3ff
		b1 = int(tsbk[6*2+0:6*2+2],16)
		b2 = int(tsbk[7*2+0:7*2+2],16)
		b3 = int(tsbk[8*2+0:8*2+2],16)
		b4 = int(tsbk[9*2+0:9*2+2],16)
		base_freq = 256*(256*(256*b1 + b2) + b3) + b4
		if (bw == 4):
			bw = 6250
		else:
			if (bw == 5):
				bw = 12500
		if (tran_off_sgn == 0):
			tran_off = -tran_off
		st = '%s\nIDEN_UP_VU opcode(hex)=%x\nmanuf_id=%d ident=%d bw(Hz)=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(Hz)=%d\n' % \
			(date_time,opcode,manuf_id,ident,bw,tran_off*chan_spac*125,chan_spac*125,base_freq*5)
		
	if (opcode == 0x1c) and (manuf_id == 0):	#MSG_UPDT
		found = 1
		msg = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nMSG_UPDT opcode(hex)=%x\nmanuf_id=%d msg=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,msg,targ_addr,src_addr)
		
	if (opcode == 0x3b) and (manuf_id == 0):	#NET_STS_BCST
		found = 1
		lra = int(tsbk[2*2+0:2*2+2],16)
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		chan = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		serv_class = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nNET_STS_BCST opcode(hex)=%x\nmanuf_id=%d lra=%d wacn_id=%d sys_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,lra,wacn_id,sys_id,chan,serv_class)
		
	if (opcode == 0x3f) and (manuf_id == 0):	#P_PARM_UPDT
		found = 1
		alg_id = int(tsbk[4*2+0:4*2+2],16)
		key_id = 256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nP_PARM_UPDT opcode(hex)=%x\nmanuf_id=%d alg_id=%d key_id=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,alg_id,key_id,targ_addr)
		
	if (opcode == 0x21) and (manuf_id == 0):	#QUE_RSP
		found = 1
		aiv = int(tsbk[2*2+0:2*2+2],16) >> 7
		serv_type = int(tsbk[2*2+0:2*2+2],16) & 0x3f
		reason = int(tsbk[3*2+0:3*2+2],16)
		info = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nQUE_RSP opcode(hex)=%x\nmanuf_id=%d aiv=%d serv_type=%d reason=%d info=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,aiv,serv_type,reason,info,targ_addr)
		
	if (opcode == 0x3a) and (manuf_id == 0):	#RFSS_STS_BCST
		found = 1
		lra = int(tsbk[2*2+0:2*2+2],16)
		a = (int(tsbk[3*2+0:3*2+2],16) >> 4) & 1
		sys_id = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16) & 0xfff
		rf_subsys_id = int(tsbk[5*2+0:5*2+2],16)
		site_id = int(tsbk[6*2+0:6*2+2],16)
		chan = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		serv_class = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nRFSS_STS_BCST opcode(hex)=%x\nmanuf_id=%d lra=%d a=%d sys_id=%d rf_subsys_id=%d site_id=%d chan=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,lra,a,sys_id,rf_subsys_id,site_id,chan,serv_class)
		
	if (opcode == 0x39) and (manuf_id == 0):	#SCCB
		found = 1
		rf_subsys_id = int(tsbk[2*2+0:2*2+2],16)
		site_id = int(tsbk[3*2+0:3*2+2],16)
		chan1 = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		serv_class1 = int(tsbk[6*2+0:6*2+2],16)
		chan2 = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		serv_class2 = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSCCB opcode(hex)=%x\nmanuf_id=%d rf_subsys_id=%d site_id=%d chan1=%d serv_class1(hex)=%x chan2=%d serv_class2(hex)=%x\n' % \
			(date_time,opcode,manuf_id,rf_subsys_id,site_id,chan1,serv_class1,chan2,serv_class2)

	if (opcode == 0x1a) and (manuf_id == 0):	#STS_Q
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSTS_Q opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)

	if (opcode == 0x18) and (manuf_id == 0):	#STS_UPDT
		found = 1
		status = 256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSTS_UPDT opcode(hex)=%x\nmanuf_id=%d status=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,status,targ_addr,src_addr)

	if (opcode == 0x38) and (manuf_id == 0):	#SYS_SRV_BCST
		found = 1
		serv_avail = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_supp = 256*(256*int(tsbk[6*2+0:6*2+2],16) + int(tsbk[7*2+0:7*2+2],16)) + int(tsbk[8*2+0:8*2+2],16)
		req_prior = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSYS_SRV_BCST opcode(hex)=%x\nmanuf_id=%d serv_avail=%d serv_supp=%d req_prior=%d\n' % \
			(date_time,opcode,manuf_id,serv_avail,serv_supp,req_prior)

	if (opcode == 0x2d) and (manuf_id == 0):	#U_REG_CMD
		found = 1
		targ_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nU_REG_CMD opcode(hex)=%x\nmanuf_id=%d targ_addr=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,targ_addr,src_addr)

	if (opcode == 0x2c) and (manuf_id == 0):	#U_REG_RSP
		found = 1
		rv = (int(tsbk[2*2+0:2*2+2],16) >> 4) & 0x3
		sys_id = (256*int(tsbk[2*2+0:2*2+2],16) + int(tsbk[3*2+0:3*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		src_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nU_REG_RSP opcode(hex)=%x\nmanuf_id=%d rv=%d sys_id=%d src_id=%d src_addr=%d\n' % \
			(date_time,opcode,manuf_id,rv,sys_id,src_id,src_addr)

	if (opcode == 0x2f) and (manuf_id == 0):	#U_DE_REG_ACK
		found = 1
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nU_DE_REG_ACK opcode(hex)=%x\nmanuf_id=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,manuf_id,wacn_id,sys_id,src_id)

	if (opcode == 0x2b) and (manuf_id == 0):	#LOC_REG_RSP
		found = 1
		rv = int(tsbk[2*2+0:2*2+2],16) & 0x3
		grp_addr = 256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)
		rf_subsys_id = int(tsbk[5*2+0:5*2+2],16)
		site_id = int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nLOC_REG_RSP opcode(hex)=%x\nmanuf_id=%d rv=%d grp_addr=%d rf_subsys_id=%d site_id=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,rv,grp_addr,rf_subsys_id,site_id,targ_addr)

	if (opcode == 0x1d) and (manuf_id == 0):	#RAD_MON_CMD
		found = 1
		tx_mult = int(tsbk[3*2+0:3*2+2],16) & 0x3
		src_addr = 256*(256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) + int(tsbk[6*2+0:6*2+2],16)
		targ_addr = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nRAD_MON_CMD opcode(hex)=%x\nmanuf_id=%d tx_mult=%d src_addr=%d targ_addr=%d\n' % \
			(date_time,opcode,manuf_id,tx_mult,src_addr,targ_addr)

	if (opcode == 0x36) and (manuf_id == 0):	#ROAM_ADDR_CMD
		found = 1
		stack_op = int(tsbk[2*2+0:2*2+2],16)
		wacn_id = (256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)) >> 4
		sys_id = (256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nROAM_ADDR_CMD opcode(hex)=%x\nmanuf_id=%d stack_op=%d wacn_id=%d sys_id=%d targ_id=%d\n' % \
			(date_time,opcode,manuf_id,stack_op,wacn_id,sys_id,targ_id)
		
	if (opcode == 0x29) and (manuf_id == 0):	#SCCB_EXP
		found = 1
		rf_subsys_id = int(tsbk[2*2+0:2*2+2],16)
		site_id = int(tsbk[3*2+0:3*2+2],16)
		chan_tx = 256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)
		chan_rx = 256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)
		serv_class = int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nSCCB_EXP opcode(hex)=%x\nmanuf_id=%d rf_subsys_id=%d site_id=%d chan_tx=%d chan_rx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,rf_subsys_id,site_id,chan_tx,chan_rx,serv_class)
			
	if (opcode == 0x32) and (manuf_id == 0):	#AUTH_FNE_RESP
		found = 1
		res2 = tsbk[3*2+0:3*2+8]
		targ_id = 256*(256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) + int(tsbk[9*2+0:9*2+2],16)
		st = '%s\nAUTH_FNE_RESP opcode(hex)=%x\nmanuf_id=%d res2=%s targ_id=%d\n' % \
			(date_time,opcode,manuf_id,res2,targ_id)
				
	if (opcode == 0x33) and (manuf_id == 0):	#IDEN_UP_TDMA
		found = 1
		ident = (int(tsbk[2*2+0:2*2+8],16) >> 4) & 0xf
		chan_type = (int(tsbk[2*2+0:2*2+8],16) >> 0) & 0xf
		tran_off = ((256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) >> 2) & 0x1fff
		tran_off_sgn = (int(tsbk[3*2+0:3*2+2],16) >> 7) & 0x1
		chan_spac = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0x3ff
		b1 = int(tsbk[6*2+0:6*2+2],16)
		b2 = int(tsbk[7*2+0:7*2+2],16)
		b3 = int(tsbk[8*2+0:8*2+2],16)
		b4 = int(tsbk[9*2+0:9*2+2],16)
		base_freq = 256*(256*(256*b1 + b2) + b3) + b4
		if (tran_off_sgn == 0):
			tran_off = -tran_off
		st = '%s\nIDEN_UP_TDMA opcode(hex)=%x\nmanuf_id=%d ident=%d chan_type=%d tran_off(Hz)=%d chan_spac(Hz)=%d base_freq(hz)=%d\n' % \
			(date_time,opcode,manuf_id,ident,chan_type,tran_off*chan_spac*125,chan_spac*125,base_freq*5)
			
	if (opcode == 0x30) and (manuf_id == 0):	#SYNC_BCST
		found = 1
		ist = (int(tsbk[3*2+0:3*2+2],16) >> 2) & 0x1
		mmu = (int(tsbk[3*2+0:3*2+2],16) >> 1) & 0x1
		mc = (((int(tsbk[3*2+0:3*2+2],16) >> 0) & 0x1) << 1) + ((int(tsbk[4*2+0:4*2+2],16) >> 7) & 0x1)
		vl = (int(tsbk[4*2+0:4*2+2],16) >> 6) & 0x1
		local_off = (int(tsbk[4*2+0:4*2+2],16) >> 0) & 0x3f
		year = int(tsbk[5*2+0:5*2+2],16) >> 1
		month = ((256*int(tsbk[5*2+0:5*2+2],16) + int(tsbk[6*2+0:6*2+2],16)) >> 5) & 0xf
		day = int(tsbk[6*2+0:6*2+2],16) & 0x1f
		hours = int(tsbk[7*2+0:7*2+2],16) >> 3
		minutes = ((256*int(tsbk[7*2+0:7*2+2],16) + int(tsbk[8*2+0:8*2+2],16)) >> 5) & 0x3f
		uslots = ((256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) >> 0) & 0x1fff
		st = '%s\nSYNC_BCST opcode(hex)=%x\nmanuf_id=%d ist=%d mmu=%d mc=%d vl=%d date(mm/dd/yy)=%2.2d/%2.2d/%2.2d time(hh:mm)=%2.2d:%2.2d uslots=%d\n' % \
			(date_time,opcode,manuf_id,ist,mmu,mc,vl,month,day,year,hours,minutes,uslots)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_voice_service_osp_mult
#############################################
def decode_voice_service_osp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	found = 0
	
	if (opcode == 0x00) and (manuf_id == 0):	#GRP_V_CH_GRANT
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		chan_tx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		chan_rx = 256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)
		grp_addr = 256*int(tsbk[18*2+0:18*2+2],16) + int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nGRP_V_CH_GRANT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d chan_tx=%d chan_rx=%d grp_addr=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,chan_tx,chan_rx,grp_addr)
	
	if (opcode == 0x05) and (manuf_id == 0):	#UU_ANS_REQ
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[13*2+0:13*2+2],16) + int(tsbk[14*2+0:14*2+2],16)) + int(tsbk[15*2+0:15*2+2],16)) >> 4
		sys_id = (256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nUU_ANS_REQ opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d serv_opt=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,serv_opt,wacn_id,sys_id,src_id)
	
	if (opcode == 0x04) and (manuf_id == 0):	#UU_V_CH_GRANT
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		targ_addr = 256*(256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)) + int(tsbk[21*2+0:21*2+2],16)
		chan_tx = 256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)
		chan_rx = 256*int(tsbk[24*2+0:24*2+2],16) + int(tsbk[25*2+0:25*2+2],16)
		st = '%s\nUU_V_CH_GRANT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d wacn_id=%d sys_id=%d src_id=%d targ_addr=%d chan_tx=%d chan_rx=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,sys_id,src_id,targ_addr,chan_tx,chan_rx)
	
	if (opcode == 0x08) and (manuf_id == 0):	#TELE_INT_CH_GRANT
		found = 1
		src_targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		chan_tx = 256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)
		chan_rx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		call_timer = 256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)
		st = '%s\nTELE_INT_CH_GRANT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_targ_addr=%d serv_opt=%d chan_tx=%d chan_rx=%d call_timer=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_targ_addr,serv_opt,chan_tx,chan_rx,call_timer)
	
	if (opcode == 0x06) and (manuf_id == 0):	#UU_V_CH_GRANT_UPDT
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		targ_addr = 256*(256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)) + int(tsbk[21*2+0:21*2+2],16)
		chan_tx = 256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)
		chan_rx = 256*int(tsbk[24*2+0:24*2+2],16) + int(tsbk[25*2+0:25*2+2],16)
		st = '%s\nUU_V_CH_GRANT_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d wacn_id=%d sys_id=%d src_id=%d targ_addr=%d chan_tx=%d chan_rx=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,sys_id,src_id,targ_addr,chan_tx,chan_rx)
	
	if (opcode == 0x09) and (manuf_id == 0):	#TELE_INT_CH_GRANT_UPDT
		found = 1
		src_targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		chan_tx = 256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)
		chan_rx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		call_timer = 256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)
		st = '%s\nTELE_INT_CH_GRANT_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_targ_addr=%d serv_opt=%d chan_tx=%d chan_rx=%d call_timer=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_targ_addr,serv_opt,chan_tx,chan_rx,call_timer)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_data_service_osp_mult
#############################################
def decode_data_service_osp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	found = 0
	
	if (opcode == 0x10) and (manuf_id == 0):	#IND_DATA_CH_GRANT
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		sys_id = (256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)) + int(tsbk[18*2+0:18*2+2],16)
		targ_addr = 256*(256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)) + int(tsbk[21*2+0:21*2+2],16)
		chan_tx = 256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)
		chan_rx = 256*int(tsbk[24*2+0:24*2+2],16) + int(tsbk[25*2+0:25*2+2],16)
		st = '%s\nIND_DATA_CH_GRANT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d wacn_id=%d sys_id=%d src_id=%d targ_addr=%d chan_tx=%d chan_rx=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,sys_id,src_id,targ_addr,chan_tx,chan_rx)
	
	if (opcode == 0x11) and (manuf_id == 0):	#GRP_DATA_CH_GRANT
		found = 1
		src_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		serv_opt = int(tsbk[8*2+0:8*2+2],16)
		chan_tx = 256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)
		chan_rx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		grp_addr = 256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)
		st = '%s\nGRP_DATA_CH_GRANT opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr=%d serv_opt=%d chan_tx=%d chan_rx=%d grp_addr=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr,serv_opt,chan_tx,chan_rx,grp_addr)

	if (found):
		d = check_var[3].get()
		if (d):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_control_status_osp_mult
#############################################
def decode_control_status_osp_mult(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	found = 0
	
	if (opcode == 0x20) and (manuf_id == 0):	#ACK_RSP_FNE
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id_src = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id_src = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		serv_type = int(tsbk[21*2+0:21*2+2],16) & 0x3f
		src_addr = 256*(256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)) + int(tsbk[24*2+0:24*2+2],16)
		wacn_id_targ = (256*(256*int(tsbk[25*2+0:25*2+2],16) + int(tsbk[26*2+0:26*2+2],16)) + int(tsbk[27*2+0:27*2+2],16)) >> 4
		sys_id_targ = (256*int(tsbk[27*2+0:27*2+2],16) + int(tsbk[28*2+0:28*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[29*2+0:29*2+2],16) + int(tsbk[30*2+0:30*2+2],16)) + int(tsbk[31*2+0:31*2+2],16)
		st = '%s\nACK_RSP_FNE opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id_src=%d sys_id_src=%d src_id=%d serv_type=%d src_addr=%d wacn_id_targ=%d sys_id_targ=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id_src,sys_id_src,src_id,serv_type,src_addr,wacn_id_targ,sys_id_targ,targ_id)

	if (opcode == 0x3c) and (manuf_id == 0):	#ADJ_STS_BCST
		found = 1
		lra = int(tsbk[3*2+0:3*2+2],16)
		c = (int(tsbk[4*2+0:4*2+2],16) >> 7) & 1
		f = (int(tsbk[4*2+0:4*2+2],16) >> 6) & 1
		v = (int(tsbk[4*2+0:4*2+2],16) >> 5) & 1
		a = (int(tsbk[4*2+0:4*2+2],16) >> 4) & 1
		sys_id = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0xfff
		rf_subsys_id = int(tsbk[8*2+0:8*2+2],16)
		site_id = int(tsbk[9*2+0:9*2+2],16)
		chan_tx = 256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)
		chan_rx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		serv_class = int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nADJ_STS_BCST opcode(hex)=%x\nmanuf_id=%d lra=%d c=%d f=%d v=%d a=%d sys_id=%d rf_subsys_id=%d site_id=%d chan_tx=%d chan_rx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,lra,c,f,v,a,sys_id,rf_subsys_id,site_id,chan_tx,chan_rx,serv_class)
	
	if (opcode == 0x1f) and (manuf_id == 0):	#CALL_ALRT
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nCALL_ALRT opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id)
	
	if (opcode == 0x24) and (manuf_id == 0):	#EXT_FNCT_CMD
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		ext_func = tsbk[14*2+0:14*2+10]
		st = '%s\nEXT_FNCT_CMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d ext_func=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,ext_func)
	
	if (opcode == 0x2a) and (manuf_id == 0):	#GRP_AFF_Q
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nGRP_AFF_Q opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id)
	
	if (opcode == 0x28) and (manuf_id == 0):	#GRP_AFF_RSP
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		wacn_id_grp = (256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)) >> 4
		sys_id_grp = (256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)) & 0xfff
		grp_id = 256*int(tsbk[21*2+0:21*2+2],16) + int(tsbk[22*2+0:22*2+2],16)
		ann_grp_id = 256*int(tsbk[23*2+0:23*2+2],16) + int(tsbk[24*2+0:24*2+2],16)
		gav = int(tsbk[25*2+0:25*2+2],16) & 0x3
		st = '%s\nGRP_AFF_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d wacn_id_grp=%d sys_id_grp=%d grp_id=%d ann_grp_id=%d gav=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id,wacn_id_grp,sys_id_grp,grp_id,ann_grp_id,gav)

	if (opcode == 0x1c) and (manuf_id == 0):	#MSG_UPDT
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		msg = 256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nMSG_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d msg=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id,msg)
	
	if (opcode == 0x3b) and (manuf_id == 0):	#NET_STS_BCST
		found = 1
		lra = int(tsbk[3*2+0:3*2+2],16)
		sys_id = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0xfff
		wacn_id = (256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)) >> 4
		chan_tx = 256*int(tsbk[15*2+0:15*2+2],16) + int(tsbk[16*2+0:16*2+2],16)
		chan_rx = 256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)
		serv_class = int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nNET_STS_BCST opcode(hex)=%x\nmanuf_id=%d lra=%d sys_id=%d wacn_id=%d chan_tx=%d chan_rx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,manuf_id,lra,sys_id,wacn_id,chan_tx,chan_rx,serv_class)
	
	if (opcode == 0x3e) and (manuf_id == 0):	#P_PARM_BCST
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		type = int(tsbk[8*2+0:8*2+2],16)
		alg_id = int(tsbk[9*2+0:9*2+2],16)
		key_id = 256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)
		in_msg = tsbk[14*2+0:14*2+9]
		out_msg = tsbk[23*2+0:23*2+9]
		st = '%s\nP_PARM_BCST opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d type=%d alg_id=%d key_id=%d in_msg=%s out_msg=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,type,alg_id,key_id,in_msg,out_msg)
	
	if (opcode == 0x3a) and (manuf_id == 0):	#RFSS_STS_BCST
		found = 1
		lra = int(tsbk[3*2+0:3*2+2],16)
		r = (int(tsbk[4*2+0:4*2+2],16) >> 5) & 1
		a = (int(tsbk[4*2+0:4*2+2],16) >> 4) & 1
		sys_id = (256*int(tsbk[4*2+0:4*2+2],16) + int(tsbk[5*2+0:5*2+2],16)) & 0xfff
		rf_subsys_id = int(tsbk[12*2+0:12*2+2],16)
		site_id = int(tsbk[13*2+0:13*2+2],16)
		chan_tx = 256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)
		chan_rx = 256*int(tsbk[16*2+0:16*2+2],16) + int(tsbk[17*2+0:17*2+2],16)
		serv_class = int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nRFSS_STS_BCST opcode(hex)=%x\nsap_ident=%d manuf_id=%d lra=%d r=%d a=%d sys_id=%d rf_sybsys_id=%d site_id=%d chan_tx=%d chan_rx=%d serv_class(hex)=%x\n' % \
			(date_time,opcode,sap_ident,manuf_id,lra,r,a,sys_id,rf_subsys_id,site_id,chan_tx,chan_rx,serv_class)
	
	if (opcode == 0x1a) and (manuf_id == 0):	#STS_Q
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		st = '%s\nSTS_Q opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id)
	
	if (opcode == 0x18) and (manuf_id == 0):	#STS_UPDT
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		status = 256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)
		st = '%s\nSTS_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d src_id=%d status=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,src_id,status)
	
	if (opcode == 0x2c) and (manuf_id == 0):	#U_REG_RSP
		found = 1
		src_addr1 = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		src_addr2 = 256*(256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)) + int(tsbk[19*2+0:19*2+2],16)
		rv = int(tsbk[20*2+0:20*2+2],16) & 0x3
		st = '%s\nU_REG_RSP opcode(hex)=%x\nsap_ident=%d manuf_id=%d src_addr1=%d wacn_id=%d sys_id=%d src_id=%d src_addr2=%d rv=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,src_addr1,wacn_id,sys_id,src_id,src_addr2,rv)
	
	if (opcode == 0x37) and (manuf_id == 0):	#ROAM_ADDR_UPDT
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		blks = (int(tsbk[6*2+0:6*2+2],16) & 0x7f) - 1
		lm = int(tsbk[8*2+0:8*2+2],16) >> 7
		msn = int(tsbk[8*2+0:8*2+2],16) & 0xf
		wacn_sys_id = tsbk[9*2+0:9*2+2] + tsbk[12*2+0:12*2+((blks*24)+6)]
		src_id = 256*(256*int(tsbk[((blks*12)+15)*2+0:((blks*12)+15)*2+2],16) + \
			int(tsbk[((blks*12)+16)*2+0:((blks*12)+16)*2+2],16)) + \
			int(tsbk[((blks*12)+17)*2+0:((blks*12)+17)*2+2],16)	
		st = '%s\nROAM_ADDR_UPDT opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d lm=%d msn=%d wacn_sys_id(hex)=%s src_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,lm,msn,wacn_sys_id,src_id)
	
	if (opcode == 0x1d) and (manuf_id == 0):	#RAD_MON_CMD
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id_src = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id_src = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		tx_time = int(tsbk[20*2+0:20*2+2],16)
		sm = (int(tsbk[21*2+0:21*2+2],16) >> 7) & 0x1
		tx_mult = (int(tsbk[21*2+0:21*2+2],16) >> 0) & 0x3
		src_addr = 256*(256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)) + int(tsbk[24*2+0:24*2+2],16)
		wacn_id_targ = (256*(256*int(tsbk[25*2+0:25*2+2],16) + int(tsbk[26*2+0:26*2+2],16)) + int(tsbk[27*2+0:27*2+2],16)) >> 4
		sys_id_targ = (256*int(tsbk[27*2+0:27*2+2],16) + int(tsbk[28*2+0:28*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[29*2+0:29*2+2],16) + int(tsbk[30*2+0:30*2+2],16)) + int(tsbk[31*2+0:31*2+2],16)
		st = '%s\nRAD_MON_CMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id_src=%d sys_id_src=%d src_id=%d tx_time=%d sm=%d tx_mult=%d src_addr=%d wacn_id_targ=%d sys_id_targ=%d targ_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id_src,sys_id_src,src_id,tx_time,sm,tx_mult,src_addr,wacn_id_targ,sys_id_targ,targ_id)
	
	if (opcode == 0x31) and (manuf_id == 0):	#AUTH_DMD
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		rs = tsbk[17*2+0:17*2+20]
		rand1 = tsbk[27*2+0:27*2+10]
		st = '%s\nAUTH_DMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d targ_id=%d rs=%s rand1=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,targ_id,rs,rand1)
	
	if (opcode == 0x32) and (manuf_id == 0):	#AUTH_FNE_RESP
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		res2 = tsbk[18*2+0:18*2+8]
		st = '%s\nAUTH_FNE_RESP opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id=%d sys_id=%d targ_id=%d res2=%s\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id,sys_id,targ_id,res2)
	
	if (opcode == 0x1e) and (manuf_id == 0) and (blks_to_follow == 1):	#RAD_MON_ENH_CMD
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		grp_id = 256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)
		src_addr = 256*(256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) + int(tsbk[14*2+0:14*2+2],16)
		sm = (int(tsbk[15*2+0:15*2+2],16) >> 7) & 0x1
		tg = (int(tsbk[15*2+0:15*2+2],16) >> 6) & 0x1
		tx_time = int(tsbk[16*2+0:16*2+2],16)
		key_id = 256*int(tsbk[17*2+0:17*2+2],16) + int(tsbk[18*2+0:18*2+2],16)
		alg_id = int(tsbk[19*2+0:19*2+2],16)
		st = '%s\nRAD_MON_ENH_CMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d type=%d alg_id=%d key_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,type,alg_id,key_id)
	
	if (opcode == 0x1e) and (manuf_id == 0) and (blks_to_follow > 1):	#RAD_MON_ENH_CMD
		found = 1
		targ_addr = 256*(256*int(tsbk[3*2+0:3*2+2],16) + int(tsbk[4*2+0:4*2+2],16)) + int(tsbk[5*2+0:5*2+2],16)
		wacn_id_src = (256*(256*int(tsbk[8*2+0:8*2+2],16) + int(tsbk[9*2+0:9*2+2],16)) + int(tsbk[12*2+0:12*2+2],16)) >> 4
		sys_id_src = (256*int(tsbk[12*2+0:12*2+2],16) + int(tsbk[13*2+0:13*2+2],16)) & 0xfff
		src_id = 256*(256*int(tsbk[14*2+0:14*2+2],16) + int(tsbk[15*2+0:15*2+2],16)) + int(tsbk[16*2+0:16*2+2],16)
		sm = (int(tsbk[17*2+0:17*2+2],16) >> 7) & 0x1
		tg = (int(tsbk[17*2+0:17*2+2],16) >> 6) & 0x1
		tx_time = int(tsbk[18*2+0:18*2+2],16)
		key_id = 256*int(tsbk[19*2+0:19*2+2],16) + int(tsbk[20*2+0:20*2+2],16)
		alg_id = int(tsbk[21*2+0:21*2+2],16)
		src_addr = 256*(256*int(tsbk[22*2+0:22*2+2],16) + int(tsbk[23*2+0:23*2+2],16)) + int(tsbk[24*2+0:24*2+2],16)
		wacn_id_targ = (256*(256*int(tsbk[25*2+0:25*2+2],16) + int(tsbk[26*2+0:26*2+2],16)) + int(tsbk[27*2+0:27*2+2],16)) >> 4
		sys_id_targ = (256*int(tsbk[27*2+0:27*2+2],16) + int(tsbk[28*2+0:28*2+2],16)) & 0xfff
		targ_id = 256*(256*int(tsbk[29*2+0:29*2+2],16) + int(tsbk[30*2+0:30*2+2],16)) + int(tsbk[31*2+0:31*2+2],16)
		wacn_id_grp = (256*(256*int(tsbk[32*2+0:32*2+2],16) + int(tsbk[33*2+0:33*2+2],16)) + int(tsbk[34*2+0:34*2+2],16)) >> 4
		sys_id_grp = (256*int(tsbk[34*2+0:34*2+2],16) + int(tsbk[35*2+0:35*2+2],16)) & 0xfff
		grp_id = 256*int(tsbk[29*2+0:29*2+2],16) + int(tsbk[30*2+0:30*2+2],16)
		st = '%s\nRAD_MON_ENH_CMD opcode(hex)=%x\nsap_ident=%d manuf_id=%d targ_addr=%d wacn_id_src=%d sys_id_src=%d src_id=%d sm=%d tg=%d tx_time=%d key_id=%d alg_id=%d src_addr=%d wacn_id_targ=%d sys_id_targ=%d targ_id=%d wacn_id_grp=%d sys_id_grp=%d grp_id=%d\n' % \
			(date_time,opcode,sap_ident,manuf_id,targ_addr,wacn_id_src,sys_id_src,src_id,sm,tg,tx_time,key_id,alg_id,src_addr,wacn_id_targ,sys_id_targ,targ_id,wacn_id_grp,sys_id_grp,grp_id)

	if (found):	
		delimit = check_var[3].get()
		if (delimit):
			st = st.replace(" ","\t")
		fout.write(st)

	return (found)


#############################################
# Function: decode_isp_single
#############################################
def decode_isp_single(tsbk,fout,date_time):
	global check_var

	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F	
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	manuf_flt = check_var[0].get()
	hex_flt = check_var[2].get()
	delimit = check_var[3].get()
	
	if (manuf_id != 0):
		
		if (manuf_flt == 0):
			st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
			if (delimit):
				st = st.replace(" ","\t")
			fout.write(st)
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)

	else:
	
		found = decode_control_status_isp_single(tsbk,fout,date_time)
	
		if (found == 0):
			found = decode_voice_service_isp_single(tsbk,fout,date_time)
	
		if (found == 0):
			found = decode_data_service_isp_single(tsbk,fout,date_time)

		if (found == 0):
			
			if (manuf_flt == 0):
				st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
				if (delimit):
					st = st.replace(" ","\t")
				fout.write(st)
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)

		else:
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)
	

#############################################
# Function: decode_osp_single
#############################################
def decode_osp_single(tsbk,fout,date_time):
	global check_var

	broadcast_flt = check_var[1].get()
	opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3F	
	manuf_id = int(tsbk[1*2+0:1*2+2],16)
	manuf_flt = check_var[0].get()
	broadcast_flt = check_var[1].get()
	hex_flt = check_var[2].get()
	delimit = check_var[3].get()
	
	if (manuf_id != 0):

		if (manuf_flt == 0):
			st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
			if (delimit):
				st = st.replace(" ","\t")
			fout.write(st)
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)

	else:
	
		found = 0
		broadcast_found = 0
		broadcast_opcodes = [0x34,0x3d,0x3c,0x3b,0x3e,0x3a,0x38,0x39]
		if (broadcast_opcodes.count(opcode) > 0) and (broadcast_flt):
			found = 1
			broadcast_found = 1
		
		if (found == 0):
			found = decode_control_status_osp_single(tsbk,fout,date_time)

		if (found == 0):
			found = decode_voice_service_osp_single(tsbk,fout,date_time)

		if (found == 0):
			found = decode_data_service_osp_single(tsbk,fout,date_time)

		if (found == 0):

			if (manuf_flt == 0):
				st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
				if (delimit):
					st = st.replace(" ","\t")
				fout.write(st)
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)

		else:
			if (broadcast_found == 0):
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)


#############################################
# Function: decode_isp_mult
#############################################
def decode_isp_mult(tsbk,fout,date_time):

	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3f
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	manuf_flt = check_var[0].get()
	hex_flt = check_var[2].get()
	delimit = check_var[3].get()
	
	if (manuf_id != 0):

		if (manuf_flt == 0):
			st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
			if (delimit):
				st = st.replace(" ","\t")
			fout.write(st)
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)

	else:
	
		found = decode_control_status_isp_mult(tsbk,fout,date_time)
	
		if (found == 0):
			found = decode_voice_service_isp_mult(tsbk,fout,date_time)

		if (found == 0):
			found = decode_data_service_isp_mult(tsbk,fout,date_time)
	
		if (found == 0):

			if (manuf_flt == 0):
				st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
				if (delimit):
					st = st.replace(" ","\t")
				fout.write(st)
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)

		else:
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)


#############################################
# Function: decode_osp_mult
#############################################
def decode_osp_mult(tsbk,fout,date_time):
	global check_var
	global multi_tsbk

	broadcast_flt = check_var[1].get()
	opcode = int(tsbk[7*2+0:7*2+2],16) & 0x3F
	sap_ident = int(tsbk[1*2+0:1*2+2],16) & 0x3f
	manuf_id = int(tsbk[2*2+0:2*2+2],16)
	manuf_flt = check_var[0].get()
	broadcast_flt = check_var[1].get()
	hex_flt = check_var[2].get()
	delimit = check_var[3].get()
	
	if (manuf_id != 0):

		if (manuf_flt == 0):
			st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
			if (delimit):
				st = st.replace(" ","\t")
			fout.write(st)
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)

	else:

		found = 0
		broadcast_found = 0
		broadcast_opcodes = [0x34,0x3d,0x3c,0x3b,0x3e,0x3a,0x38,0x39]
		if (broadcast_opcodes.count(opcode) > 0) and (broadcast_flt):
			found = 1
			broadcast_found = 1

		if (found == 0):
			found = decode_control_status_osp_mult(tsbk,fout,date_time)
			
		if (found == 0):
			found = decode_voice_service_osp_mult(tsbk,fout,date_time)
		
		if (found == 0):
			found = decode_data_service_osp_mult(tsbk,fout,date_time)

		if (found == 0):

			if (manuf_flt == 0):
				st = '%s\nNon-Standard opcode(hex)=%x manuf_id(hex)=%x\n' % (date_time,opcode,manuf_id)
				if (delimit):
					st = st.replace(" ","\t")
				fout.write(st)
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)

		else:
			if (broadcast_found == 0):
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)


#############################################
# Function: decode_isp
#############################################
def decode_isp(str,fout):
	global blocks_to_follow

	#
	#	Decode NAC and DUID
	#

	date_time = str[:19]
	date_time = date_time.replace("\t"," ")
	
	ndx = str.find("GPS")
	if ndx>=0:
		gps_str = str[ndx:len(str)-2]
		str = str[:ndx-1]
		str = str + "\n"
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		gps_str = gps_str + "\t"
		gps_str = gps_str.replace("\t"," ")
		date_time = gps_str + date_time
	
	tsbk = str[20:55]
	tsbk = (tsbk.replace("\t","")).replace(" ","")
	nac_duid = str[56:len(str)]
	ndx = nac_duid.find('\t')
	tsbk_valid = nac_duid[0:ndx] 
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	duid = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac_valid = nac_duid[0:ndx]
	
	#
	# Compute CRC to verify decoding
	#

	error_flag = 0
	crc = crc16(tsbk)
	
	fmat = int(tsbk[0*2+0:0*2+2],16) & 0x1F

	if (duid != 7):

		#
		# Multiple packet message
		#
				
		if (blocks_to_follow == 0):
			multi_tsbk = tsbk
			if (crc == 0) and (fmat == 0x17):
				blocks_to_follow = int(tsbk[6*2+0:6*2+2],16) & 0x7F
			else:
				blocks_to_follow = 0
		else:
			blocks_to_follow = blocks_to_follow - 1
			multi_tsbk = multi_tsbk + tsbk

			if (blocks_to_follow == 0):
				crc = crc32(multi_tsbk)
				if (crc == 0):
					decode_isp_mult(multi_tsbk,fout,date_time)
				else:
					error_flag = 1

	else:

		#
		# Single OSP packet message
		#
	
		if (crc == 0):
			decode_isp_single(tsbk,fout,date_time)				
		else:
			error_flag = 1
	
	return (error_flag)

#############################################
# Function: decode_osp
#############################################
def decode_osp(str,fout):
	global blocks_to_follow
	global multi_tsbk
	global ent2
	global last_count
	global total_packet_count

	#
	#	Decode NAC and DUID
	#

	date_time = str[:19]
	date_time = date_time.replace("\t"," ")
	
	ndx = str.find("GPS")
	if ndx>=0:
		gps_str = str[ndx:len(str)-2]
		str = str[:ndx-1]
		str = str + "\n"
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		gps_str = gps_str + "\t"
		gps_str = gps_str.replace("\t"," ")
		date_time = gps_str + date_time
	
	tsbk = str[20:55]
	tsbk = (tsbk.replace("\t","")).replace(" ","")
	nac_duid = str[56:len(str)]
	ndx = nac_duid.find('\t')
	tsbk_valid = nac_duid[0:ndx] 
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	duid = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac_valid = nac_duid[0:ndx]
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\n')
	counter = int(nac_duid[0:ndx],16)
	total_packet_count = total_packet_count + 1

	if (counter != ((last_count + 1) & 0xFFFF)) and (last_count > 0):
		txt1 = ent2.get()
		ent2.delete(0,len(txt1))
		txt1 = 'Restart at=%d' % (total_packet_count)
		ent2.insert(0,txt1)
		ent2.update()

	last_count = counter
	
	#
	# Compute CRC to verify decoding
	#

	error_flag = 0
	crc = crc16(tsbk)
	
	fmat = int(tsbk[0*2+0:0*2+2],16) & 0x1F
	
	if (duid != 7):

		#
		# Multiple packet message
		#

		if (blocks_to_follow == 0):
			multi_tsbk = tsbk
			if (crc == 0) and (fmat == 0x17):
				blocks_to_follow = int(tsbk[6*2+0:6*2+2],16) & 0x7F
			else:
				blocks_to_follow = 0
		else:
			blocks_to_follow = blocks_to_follow - 1
			multi_tsbk = multi_tsbk + tsbk
				
			if (blocks_to_follow == 0):
				crc = crc32(multi_tsbk)
				if (crc != 0):
					error_flag = 1
					st = '********CRC ERROR=0x%x\n' % (crc)
					fout.write(st)

				decode_osp_mult(multi_tsbk,fout,date_time)
		
	else:

		#
		# Single OSP packet message
		#
	
		if (crc != 0):
			error_flag = 1
			st = '********CRC ERROR=0x%x\n' % (crc)
			fout.write(st)
			
		decode_osp_single(tsbk,fout,date_time)				

	return (error_flag)


#############################################
# Function: decode_voice
#############################################
def decode_voice(str,fout):
	global voice_link_control
	global voice_link_control_count
	global check_var
	global ent2
	global last_count
	global total_packet_count

	manuf_flt = check_var[0].get()
	broadcast_flt = check_var[1].get()
	hex_flt = check_var[2].get()
	delimit = check_var[3].get()

	#
	#	Decode NAC and DUID
	#

	date_time = str[:19]
	date_time = date_time.replace("\t"," ")
	
	ndx = str.find("GPS")
	if ndx>=0:
		gps_str = str[ndx:len(str)-2]
		str = str[:ndx-1]
		str = str + "\n"
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		ndx = gps_str.rfind("\t")
		gps_str = gps_str[:ndx-1]
		gps_str = gps_str + "\t"
		gps_str = gps_str.replace("\t"," ")
		date_time = gps_str + date_time
	
	if (str[32] == "\t"):	# low speed data
		tsbk = str[20:31]
		tsbk = (tsbk.replace("\t","")).replace(" ","")
		nac_duid = str[32:len(str)]
	else:							# link control
		tsbk = str[20:47]
		tsbk = (tsbk.replace("\t","")).replace(" ","")
		nac_duid = str[48:len(str)]

	while (nac_duid[0] == '\t'):
		nac_duid = nac_duid[1:len(nac_duid)]
	
	ndx = nac_duid.find('\t')
	tsbk_valid = nac_duid[0:ndx] 
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	duid = int(nac_duid[0:ndx],16)
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\t')
	nac_valid = nac_duid[0:ndx]
	nac_duid = nac_duid[ndx+1:len(nac_duid)]
	ndx = nac_duid.find('\n')
	counter = int(nac_duid[0:ndx],16)

	if (duid == 5):
		total_packet_count = total_packet_count + 1
		
		if (counter != ((last_count + 1) & 0xFFFF)) and (last_count > 0):
			txt1 = ent2.get()
			ent2.delete(0,len(txt1))
			txt1 = 'Restart at=%d' % (total_packet_count)
			ent2.insert(0,txt1)
			ent2.update()

		last_count = counter
		
	if (duid == 5):	# link control

		#
		#	Decode link control
		#

		voice_link_control = tsbk
		opcode = int(tsbk[0*2+0:0*2+2],16) & 0x3f
		
		found = 0
		broadcast_opcodes = [0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29]
		if (broadcast_opcodes.count(opcode) > 0) and (broadcast_flt):
			found = 1

		if (found == 0):
			found = decode_link_control(tsbk,fout,date_time)
		
		if (found == 0):

			if (manuf_flt == 0):
				st = '%s Non-Standard opcode(hex)=%x\n' % (date_time,opcode)
				if (delimit):
					st = st.replace(" ","\t")
				fout.write(st)
				if (hex_flt == 0):
					st = 'msg=%s\n\n' % (tsbk)
				else:
					st = '\n'
				fout.write(st)

		else:
			if (hex_flt == 0):
				st = 'msg=%s\n\n' % (tsbk)
			else:
				st = '\n'
			fout.write(st)


#############################################
# Function: decode_file
#############################################
def decode_file():
	global control_iden_up
	global control_iden_up_count
	global control_adj_sts_bcst
	global control_adj_sts_bcst_count
	global control_net_sts_bcst
	global control_net_sts_bcst_count
	global control_p_parm_bcst
	global control_p_parm_bcst_count
	global control_rfss_sts_bcst
	global control_rfss_sts_bcst_count
	global control_sys_srv_bcst
	global control_sys_srv_bcst_count
	global control_sccb
	global control_sccb_count
	global voice_link_control
	global voice_link_control_count
	global check_var
	global ent
	global blocks_to_follow
	global multi_tsbk

	#
	#	Initialize broadcast messages
	#

	control_adj_sts_bcst = 'ADJ_STS_BCST'
	control_adj_sts_bcst_count = 0
	control_iden_up = 'IDEN_UP'
	control_iden_up_count = 0
	control_net_sts_bcst = 'NET_STS_BCST'
	control_net_sts_bcst_count = 0
	control_p_parm_bcst = 'P_PARM_BCST'
	control_p_parm_bcst_count = 0
	control_rfss_sts_bcst = 'RFSS_STS_BCST'
	control_rfss_sts_bcst_count = 0
	control_sccb = 'SCCB'
	control_sccb_count = 0
	control_sys_srv_bcst = 'SYS_SRV_BCST'
	control_sys_srv_bcst_count = 0
	voice_link_control = 'LINK_CONTROL'
	voice_link_control_count = 0

	fname = tkFileDialog.askopenfilename(filetypes=[])
	fname_out = fname[0:len(fname)-4] + '.txt'
	
	txt1 = ent.get()
	ent.delete(0,len(txt1))
	txt1 = 'Processing file'
	ent.insert(0,txt1)

	ndx = fname.rfind('/')
	if (fname[ndx+1] == 'V'):
		ctrl = 0
	else: 
		ctrl = 1	

	osp = check_var[4].get()
				
	#
	#	Ignore header information
	#

	fout = open(fname_out,'w')
	f = open(fname,'r')
	f.seek(0)
	while True:
		str = f.readline()
		#print '%s' % (str)
		#time.sleep(1)
	
		if (len(str) >= 10):
			if (str[:10] == '<APP_DATA>') or (str[:12] == '<ASCII_DATA>'):
				str = f.readline()
				break
	
	#
	#	Initialize broadcast messages
	#

	control_adj_sts_bcst = 'ADJ_STS_BCST'
	control_adj_sts_bcst_count = 0
	control_iden_up = 'IDEN_UP'
	control_iden_up_count = 0
	control_net_sts_bcst = 'NET_STS_BCST'
	control_net_sts_bcst_count = 0
	control_p_parm_bcst = 'P_PARM_BCST'
	control_p_parm_bcst_count = 0
	control_rfss_sts_bcst = 'RFSS_STS_BCST'
	control_rfss_sts_bcst_count = 0
	control_sccb = 'SCCB'
	control_sccb_count = 0
	control_sys_srv_bcst = 'SYS_SRV_BCST'
	control_sys_srv_bcst_count = 0
	voice_link_control = 'LINK_CONTROL'
	voice_link_control_count = 0

	#
	#	Process TSBK data
	#

	multi_tsbk = 0
	blocks_to_follow = 0
	tsbk_limit = 0
	tsbk_count = 0
	error_count = 0

	while True:
		str = f.readline()
		if (len(str) < 10):
			break

		if (ctrl == 0):	# voice channel
			decode_voice(str,fout)
		else:
			if (osp == 0):	# control channel (isp)
				error_flag = decode_isp(str,fout)
				error_count = error_count + error_flag
			else:				# control channel (osp)
				error_flag = decode_osp(str,fout)
				error_count = error_count + error_flag
		
		if ((tsbk_count & 0x3ff) == 0):
			txt1 = ent.get()
			ent.delete(0,len(txt1))
			txt1 = 'CRC errors=%d out of %d' % (error_count,tsbk_count)
			ent.insert(0,txt1)
			ent.update()

		tsbk_count = tsbk_count + 1
		if (tsbk_count >= tsbk_limit) and (tsbk_limit > 0):
			break
			
	txt1 = ent.get()
	ent.delete(0,len(txt1))
	txt1 = 'CRC errors=%d out of %d (DONE)' % (error_count,tsbk_count)
	ent.insert(0,txt1)
	ent.update()
			
	fout.write('<APP_SUMMARY>\n')
	fout.write('CRC errors = %d out of %d\n\n' % (error_count,tsbk_count))

	fout.write('<APP_FIELD_DESCRIPTIONS>\n')
	fout.write('System Service Class\n')
	fout.write('--------------------\n')
	fout.write('0x01 - composite control channel\n')
	fout.write('0x02 - no service requests; update control channel only\n')
	fout.write('0x04 - backup control channel only\n')
	fout.write('0x08 - reserved for future definition\n')
	fout.write('0x10 - data service requests only\n')
	fout.write('0x20 - voice service requests only\n')
	fout.write('0x40 - registration services only\n')
	fout.write('0x80 - authentication service only\n')

	f.close()
	fout.close()


#############################################
# main
#############################################

#
#	Initialize globals
#

control_iden_up_vu = 'IDEN_UP_VU'
control_iden_up_vu_count = 0
control_adj_sts_bcst = 'ADJ_STS_BCST'
control_adj_sts_bcst_count = 0
control_iden_up = 'IDEN_UP'
control_iden_up_count = 0
control_net_sts_bcst = 'NET_STS_BCST'
control_net_sts_bcst_count = 0
control_p_parm_bcst = 'P_PARM_BCST'
control_p_parm_bcst_count = 0
control_rfss_sts_bcst = 'RFSS_STS_BCST'
control_rfss_sts_bcst_count = 0
control_sccb = 'SCCB'
control_sccb_count = 0
control_sys_srv_bcst = 'SYS_SRV_BCST'
control_sys_srv_bcst_count = 0
voice_link_control = 'LINK_CONTROL'
voice_link_control_count = 0
blocks_to_follow = 0
multi_tsbk = 0
last_count = -1
total_packet_count = 0

#
#	Create GUI
#

root=Tkinter.Tk()
LabelText="P25 Control Channel Decoder"
LabelWidget=Tkinter.Label(root,text=LabelText)
LabelWidget.pack()

ent = Tkinter.Entry(root, width=40)
ent.insert(0,'Select File')
ent.pack({"side": "top"})

ent2 = Tkinter.Entry(root, width=40)
ent2.insert(0,'   ')
ent2.pack({"side": "top"})

check_var = []
check_var.append(Tkinter.IntVar())
check_var.append(Tkinter.IntVar())
check_var.append(Tkinter.IntVar())
check_var.append(Tkinter.IntVar())
check_var.append(Tkinter.IntVar())
check_var[0].set(0)
check_var[1].set(0)
check_var[2].set(0)
check_var[3].set(1)
check_var[4].set(1)

#toolbar = Tkinter.Frame(root)
#toolbar.pack({"side": "left"})
manuf_filter = Tkinter.Checkbutton(text="Non-Standard Filter", justify="left", width=40, onvalue = 1, offvalue = 0, variable=check_var[0])
manuf_filter.pack({"side": "top"})
check_filter = Tkinter.Checkbutton(text="Broadcast Filter        ", justify="left", width=40, onvalue = 1, offvalue = 0, variable=check_var[1])
check_filter.pack({"side": "top"})
hex_filter = Tkinter.Checkbutton(text="Hex Filter                  ", justify="left", width=40, onvalue = 1, offvalue = 0, variable=check_var[2])
hex_filter.pack({"side": "top"})
delimiter = Tkinter.Checkbutton(text="Tab Delimit               ", justify="left", width=40, onvalue = 1, offvalue = 0, variable=check_var[3])
delimiter.pack({"side": "top"})
osp_select = Tkinter.Checkbutton(text="Outbound                 ", justify="left", width=40, onvalue = 1, offvalue = 0, variable=check_var[4])
osp_select.pack({"side": "top"})
file_select = Tkinter.Button(text="Select File", justify="center", width=20, command=decode_file)
file_select.pack({"side": "top"})

frame =Tkinter.Frame(root, bd=1)
frame.pack()

root.mainloop()


